#pragma once

#include <tchar.h>
#include <Windows.h>
#include "constants.hpp"
#include "StandardMidiFormat.hpp"

#undef ALTERNATE

/**
 * AvP[ṼL[oChݒ
 *
 * L[蓖ď2oCg̃f[^ňȉ̈Ӗ
 * 1oCg: CL[(ModifierKeyOR)
 * 1oCg: zL[R[h(VK_AȂ)
 */
class KeyBind
{
public:

	/**
	 * L[oChf[^̂ǂɉĂ邩̏
	 */
	enum Index : size_t
	{
		NOTE_NUMBER = 0, // MINIMUM_NOTE_NUMBER
		HOTKEY_PLAY = NOTE_NUMBER + MAXIMUM_NOTE_NUMBER - MINIMUM_NOTE_NUMBER + 1, // Đ/~̃zbgL[
		HOTKEY_MIDI_INPUT,
		HOTKEY_ALL_STOP,
		LENGTH,
	};

	/**
	 * CL[bit
	 */
	enum ModifierKey : WORD
	{
		SHIFT     = 0x0100,
		CONTROL   = 0x0200,
		ALTERNATE = 0x0400,
	};

	/**
	 * RXgN^
	 */
	KeyBind();

	/**
	 * m[gԍɑ΂L[蓖Ă擾
	 *
	 * @param noteNumber m[gԍ
	 *
	 * @return L[蓖ď
	 */
	WORD getNoteNumber(BYTE noteNumber) const;

	/**
	 * Đ/~̃zbgL[蓖Ă擾
	 *
	 * @return L[蓖ď
	 */
	WORD getPlayHotKey() const;

	/**
	 * MIDI͎t̃zbgL[蓖Ă擾
	 *
	 * @return L[蓖ď
	 */
	WORD getMidiInputHotKey() const;

	/**
	 * S~̃zbgL[蓖Ă擾
	 *
	 * @return L[蓖ď
	 */
	WORD getAllStopHotKey() const;

	/**
	 * L[[蓖Ă擾
	 *
	 * @param index Ώۂ̃L[oCh(keyBinds_̃CfbNX)
	 *
	 * @return L[蓖ď
	 */
	WORD get(size_t index) const;

	/**
	 * L[蓖Ăݒ
	 *
	 * @param index Ώۂ̃L[oCh(keyBinds_̃CfbNX)
	 * @param key L[蓖ď
	 */
	void set(size_t index, WORD key);

private:

	/**
	 * .init@Cł̃ZNV
	 */
	static constexpr const TCHAR* INI_SECTION = _T("KeyBinds");

	/**
	 * .init@C̃L[
	 */
	static const TCHAR* const INI_KEYS[Index::LENGTH];

	/**
	 * ftHg̃L[oCh
	 *
	 * N.init@Cǂݍ߂Ȃꍇɂgp
	 */
	static const WORD DEFAULT_KEY_BINDS[Index::LENGTH];

	/**
	 * L[oChf[^
	 */
	WORD keyBinds_[Index::LENGTH];

	/**
	 * .init@CL[oChǂݍ
	 *
	 * @param index Ώۂ̃L[oCh(keyBinds_̃CfbNX)
	 */
	void read(size_t index);

	/**
	 * .init@CփL[oCho
	 *
	 * @param index Ώۂ̃L[oCh(keyBinds_̃CfbNX)
	 */
	void write(size_t index);
};
