#pragma once

#include <tchar.h>
#include <Windows.h>

class KeyBind;
class MidiSynthesizer;
class KeyboardSynthesizer;
class KeySequencer;
class MidiInput;

/**
 * CEBhE
 */
class MainWindow
{
public:

	/**
	 * Hotkey: Đ/~o^pID
	 */
	static constexpr size_t ID_HOTKEY_PLAY = 100;

	/**
	 * Hotkey: MIDI͓o^pID
	 */
	static constexpr size_t ID_HOTKEY_MIDI_INPUT = 101;

	/**
	 * Hotkey: S~
	 */
	static constexpr size_t ID_HOTKEY_ALL_STOP = 102;

	/**
	 * RXgN^
	 *
	 * @param hInstance AvP[ṼCX^Xnh
	 */
	MainWindow(HINSTANCE hInstance);

	/**
	 * fXgN^
	 */
	~MainWindow();

	/**
	 * EBhȄ
	 *
	 * 1xsȂ
	 * 2ڈȍ~̌Ăяo͉sȂ
	 *
	 * @return ɏIꍇtrueԂ
	 */
	bool initialize();

	/**
	 * EBhẼbZ[W
	 *
	 * EBhE݂菈p
	 * EBhEꂽɏԂ
	 */
	void run();

private:

	/**
	 * Window classo^鎞̖
	 */
	static constexpr const TCHAR* WINDOW_CLASS_NAME = _T("MainWindow");

	/**
	 * NCAg̈̕
	 */
	static constexpr int CLIENT_WIDTH = 480;

	/**
	 * NCAg̈̍
	 */
	static constexpr int CLIENT_HEIGHT = 8 + 30 + 8 + 30 + 8 + 30 + 8;

	/**
	 * L[oChݒ{^ID
	 */
	static constexpr size_t ID_BUTTON_KEY_BIND = 100;
	
	/**
	 * eXgĐ/~{^ID
	 */
	static constexpr size_t ID_BUTTON_TEST_PLAY = 101;

	/**
	* sς݃tO
	*/
	bool initialized_;

	/**
	* AvP[ṼCX^Xnh
	*/
	HINSTANCE instanceHandle_;

	/**
	 * EBhEnh
	 */
	HWND windowHandle_;

	/**
	 * t@C\static textnh
	 */
	HWND fileTextHandle_;

	/**
	 * ĐXe[^X\static textnh
	 */
	HWND statusTextHandle_;

	/**
	 * L[oChJbuttoñnh
	 */
	HWND openKeyBindButtonHanndle_;

	/**
	 * eXgĐ/~{^
	 */
	HWND testPlayButtonHandle_;

	/**
	 * o^ꂽĐ/~zbgL[
	 */
	WORD playHotKeyRegistered_;

	/**
	 * o^ꂽMIDI̓zbgL[
	 */
	WORD midiInputHotKeyRegistered_;

	/**
	 * o^ꂽS~zbgL[
	 */
	WORD allStopHotKeyRegistered_;

	/**
	 * L[oCh
	 */
	KeyBind* keyBind_;

	/**
	 * L[{[h͂Ƃďo͂VZTCU[
	 */
	KeyboardSynthesizer* keyboardSynthesizer_;

	/**
	 * MIDIgpĉo͂VZTCU[
	 */
	MidiSynthesizer* midiSynthesizer_;

	/**
	 * t
	 */
	KeySequencer* keySequencer_;

	/**
	 * MIDI͏
	 */
	MidiInput* midiInput_;

	/**
	 * Window class̓o^1xsp̊֐
	 *
	 * Window class̓o^s
	 *
	 * @param instanceHandle AvP[ṼCX^Xnh
	 *
	 * @return Œ0Ԃ
	 */
	static int registerWindowClass(HINSTANCE instanceHandle);

	/**
	 * VXeR[obNEBhEvV[W
	 */
	static LRESULT WINAPI callbackProcedure(HWND windowHandle, UINT message, WPARAM wParam, LPARAM lParam);

	/**
	 * EBhEvV[We
	 */
	LRESULT procedure(HWND windowHandle, UINT message, WPARAM wParam, LPARAM lParam);

	/**
	 * zbgL[o^
	 */
	void RegisterHotKeys();

	/**
	 * zbgL[
	 */
	void UnregisterHotKeys();

	/**
	 * tԂɕ\؂ւ
	 */
	void refreshStatus();
};
